#include <sys/types.h>

#define u8	u_int8_t
#define u16	u_int16_t
#define u32	u_int32_t

#define swab16(x) \
({ \
	u16 __x = (x); \
	((u16)( \
		(((u16)(__x) & (u16)0x00ffU) << 8) | \
		(((u16)(__x) & (u16)0xff00U) >> 8) )); \
})

#define swab32(x) \
({ \
	u32 __x = (x); \
	((u32)( \
		(((u32)(__x) & (__u32)0x000000ffUL) << 24) | \
		(((u32)(__x) & (__u32)0x0000ff00UL) <<  8) | \
		(((u32)(__x) & (__u32)0x00ff0000UL) >>  8) | \
		(((u32)(__x) & (__u32)0xff000000UL) >> 24) )); \
})

#if __BYTE_ORDER == __LITTLE_ENDIAN

#define cpu_to_le16(x)	((u16)(x))
#define cpu_to_be16(x)	swab16((x))
#define le16_to_cpu(x)	((u16)(x))
#define be16_to_cpu(x)	swab16((x))
#define	cpu_to_le32(x)	((u32)(x))
#define cpu_to_be32(x)	swab32((x))
#define le32_to_cpu(x)	((u32)(x))
#define be32_to_cpu(x)	swab32((x))

#else

#define cpu_to_le32(x) swab32((x))
#define cpu_to_be32(x) ((u32)(x))
#define le32_to_cpu(x) swab32((x))
#define be32_to_cpu(x) ((u32)(x))
#define cpu_to_le16(x) swab16((x))
#define cpu_to_be16(x) ((u16)(x))
#define le16_to_cpu(x) swab16((x))
#define be16_to_cpu(x) ((u16)(x))

#endif
